'use strict';

var jsxRuntime = require('react/jsx-runtime');
var react = require('react');

/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __rest(s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
}

var LineWrappingInput = react.forwardRef(function (_a, ref) {
    var containerClassName = _a.containerClassName, _b = _a.containerStyle, containerStyle = _b === void 0 ? {} : _b, _c = _a.suffix, suffix = _c === void 0 ? " " : _c, suffixClassName = _a.suffixClassName, suffixStyle = _a.suffixStyle, blurOnLineBreak = _a.blurOnLineBreak, onReturn = _a.onReturn, readOnly = _a.readOnly, _d = _a.overlapTechnique, overlapTechnique = _d === void 0 ? "grid" : _d, multiline = _a.multiline, props = __rest(_a, ["containerClassName", "containerStyle", "suffix", "suffixClassName", "suffixStyle", "blurOnLineBreak", "onReturn", "readOnly", "overlapTechnique", "multiline"]);
    var _e = react.useState(props.value), value = _e[0], setValue = _e[1];
    react.useEffect(function () { return setValue(props.value); }, [props.value]);
    var handleChange = react.useCallback(function (event) {
        var _a;
        // Strip line breaks when not multiline
        var newValue = multiline
            ? event.target.value
            : event.target.value.replace(/\r|\n/g, "");
        // Override user typing line breaks. Doesn't fire if the line break was pasted, that's handled by the else block.
        if (event.nativeEvent.inputType === "insertLineBreak" &&
            !multiline) {
            if (blurOnLineBreak) {
                event.target.blur();
            }
            onReturn === null || onReturn === void 0 ? void 0 : onReturn(__assign(__assign({}, event), { target: __assign(__assign({}, event.target), { value: newValue }) }));
        }
        else {
            (_a = props.onChange) === null || _a === void 0 ? void 0 : _a.call(props, __assign(__assign({}, event), { target: __assign(__assign({}, event.target), { value: newValue }) }));
            setValue(newValue);
        }
    }, [props.onChange, setValue]);
    return (jsxRuntime.jsxs("div", __assign({ className: "line-wrapping-input-container ".concat(containerClassName || ""), style: __assign(__assign(__assign({}, containerStyle), { overflow: "auto" }), (overlapTechnique === "grid"
            ? { display: "grid" }
            : { position: "relative" })) }, { children: [!readOnly && (jsxRuntime.jsx("textarea", __assign({}, props, { className: "line-wrapping-input ".concat(props.className || ""), value: value, "aria-multiline": multiline, style: __assign(__assign(__assign({}, (props.style || {})), (overlapTechnique === "grid"
                    ? { gridArea: "1 / 1 / 2 / 2" }
                    : { inset: 0, position: "absolute" })), { minWidth: 0, overflow: "clip", overflowWrap: "break-word", resize: "none", whiteSpace: "pre-wrap" }), onChange: handleChange, rows: 1, ref: ref }))), jsxRuntime.jsxs("div", __assign({ className: "line-wrapping-input ".concat(props.className || ""), style: __assign(__assign(__assign({}, (props.style || {})), (overlapTechnique === "grid"
                    ? {
                        gridArea: "1 / 1 / 2 / 2",
                    }
                    : {})), { overflow: "clip", overflowWrap: "break-word", pointerEvents: "none", whiteSpace: "pre-wrap" }) }, { children: [jsxRuntime.jsx("span", __assign({ "aria-hidden": !readOnly, style: { visibility: readOnly ? "visible" : "hidden" } }, { children: value || props.placeholder })), jsxRuntime.jsx("span", __assign({ className: "line-wrapping-input-suffix ".concat(suffixClassName || ""), style: suffixStyle }, { children: suffix }))] }))] })));
});

module.exports = LineWrappingInput;
//# sourceMappingURL=index.cjs.map
